unit Draw;

interface

uses Graphics, LCLType;//Windows, Kol;

//const

type
  COLOR16        = $0000..$FF00;



function GetLightColor(Color: TColor; Light: Byte): TColor;
{   }

function GetShadeColor(Color: TColor; Shade: Byte): TColor;
{   }

function GetColorBetween(StartColor, EndColor: TColor; PointValue, vMin,
                         vMax : Extended): TColor;
{   
    vMin -     ,  StartColor
    vMax -     ,  EndColor
    PointValue -    vMin  vMax,  
                      
 }

implementation

function GetLightColor(Color: TColor; Light: Byte): TColor;
var fFrom: TRGBQuad;
begin
//  fFrom := Color2RGBQuad(Color);
  RedGreenBlue(ColorToRGB(Color), fFrom.rgbRed, fFrom.rgbGreen, fFrom.rgbBlue);
  //Result := RGB(
  Result := RGBToColor(
    (fFrom.rgbRed * 100 + (255 - fFrom.rgbRed) * Light) div 100,
    (fFrom.rgbGreen * 100 + (255 - fFrom.rgbGreen) * Light) div 100,
    (fFrom.rgbBlue * 100 + (255 - fFrom.rgbBlue) * Light) div 100);
end;

function GetShadeColor(Color: TColor; Shade: Byte): TColor;
var fFrom: TRGBQuad;
begin
//  fFrom := Color2RGBQuad(Color);
  RedGreenBlue(ColorToRGB(Color), fFrom.rgbRed, fFrom.rgbGreen, fFrom.rgbBlue);
  //Result := RGB(
  Result := RGBToColor(
    Max(0, fFrom.rgbRed - Shade),
    Max(0, fFrom.rgbGreen - Shade),
    Max(0, fFrom.rgbBlue - Shade));
end;

function GetColorBetween;
var F: Extended;
    fFrom1, fFrom2: TRGBQuad;

    function CalcColorBytes(fb1, fb2: Byte): Byte;
    begin
      Result := fb1;
      if (fb1 < fb2) then Result := fb1 + Trunc(F * (fb2 - fb1));
      if (fb1 > fb2) then Result := fb1 - Trunc(F * (fb1 - fb2));
    end;

begin
  if (PointValue <= vMin) or (StartColor = EndColor) then
  begin
    Result := StartColor;
    Exit;
  end;
  if (PointValue >= vMax) then
  begin
    Result := EndColor;
    Exit;
  end;
  F := (PointValue - vMin) / (vMax - vMin);
  //=====================- asm trans -===========================
//  fFrom1 := Color2RGBQuad(StartColor);
//  fFrom2 := Color2RGBQuad(EndColor);
  RedGreenBlue(ColorToRGB(Color), fFrom1.rgbRed, fFrom1.rgbGreen, fFrom1.rgbBlue);
  RedGreenBlue(ColorToRGB(Color), fFrom2.rgbRed, fFrom2.rgbGreen, fFrom2.rgbBlue);
//  Result := RGB(CalcColorBytes(fFrom1.rgbRed, fFrom2.rgbRed),
  Result := RGBToColor(CalcColorBytes(fFrom1.rgbRed, fFrom2.rgbRed),
                   CalcColorBytes(fFrom1.rgbGreen, fFrom2.rgbGreen),
                   CalcColorBytes(fFrom1.rgbBlue, fFrom2.rgbBlue));
  //=============================================================
end;

end.