unit Share;

{$mode Delphi}
{$H+}

interface

uses SysUtils, Classes, Graphics, LCLType, LCLProc;

type
  THIPicture = class(TPicture)
    public
      procedure LoadFromHiResName(Instance: THandle; const ResName: String);
  end;

procedure Replace(var Str: String; const SubStr, DestStr: String );

implementation

procedure THIPicture.LoadFromHiResName(Instance: THandle; const ResName: String);
var
  Stream: TResourceStream;
  ResType: TResourceType;
begin
  ResType := RT_BITMAP;

  Stream := TResourceStream.Create(Instance, ResName, ResType);
  try
    LoadFromStreamWithFileExt(Stream, 'bmp');
  finally
    Stream.Free;
  end;
end;

procedure Replace;
var p: Integer;
begin
  p := UTF8Pos(SubStr, Str);
  while p > 0 do
  begin
    UTF8Delete(Str, p, UTF8Length(SubStr));
    UTF8Insert(DestStr, Str, p);
    //p := PosEx(substr,str,p + Length(dest));
    p := UTF8Pos(SubStr, Str);
  end;
end;

end.